/**
 *  Please read the terms of the CLUF license attached to this module(cf "licences" folder)
 *
 * @author    Línea Gráfica E.C.E. S.L.
 * @copyright Lineagrafica.es - Línea Gráfica E.C.E. S.L. all rights reserved.
 * @license   https://www.lineagrafica.es/licenses/license_en.pdf
 *            https://www.lineagrafica.es/licenses/license_es.pdf
 *            https://www.lineagrafica.es/licenses/license_fr.pdf
 */

window.addEventListener('load',function() {

    var filkers = {
        pcommon: {
            'ajax': 1,
            'controller': 'AdminFilkersAjax',
            'module_name': 'filkers',
            'configure': 'filkers',
            'token': filkers_token,
            'rand': new Date().getTime()
        },

        ajaxCall: function (params, callback) {
            filkers.isLoading();
            if (typeof params.data != 'undefined') {
                var contentType = false;
                var processData = false;
                var data = params.data;
                delete params.data;
                Object.assign(params, this.pcommon);
                $.each(params, function(index, value) {
                    data.append(index, value);
                });
            } else {
                var contentType = 'application/x-www-form-urlencoded; charset=UTF-8';
                var processData = true;
                var data = {};
                Object.assign(data, this.pcommon, params);
            }
            return $.ajax({
                'url': './index.php',
                'method': 'post',
                'dataType': 'json',
                'contentType': contentType,
                'processData': processData,
                'cache': false,
                'data': data,
                'success': function (data) {
                    filkers.isFinished();
                    if (typeof callback != 'undefined') {
                        eval(callback+'(params, data)');
                    }
                },
                'error': function (data) {
                    filkers.isFinished();
                },
                'xhr': function() {
                    var xhr = $.ajaxSettings.xhr();
                    if(xhr.upload){
                        xhr.upload.addEventListener('progress', function(event) {
                            var percent = 0;
                            if (event.lengthComputable) {
                                percent = Math.ceil(event.loaded / event.total * 100);
                            }
                        }, false);
                    }
                    return xhr;
                },
            });
        },
        isLoading: function(obj, mode) {
            if (typeof obj == 'undefined') {
                var obj = $('.filkers-loading');
            }
            if (typeof mode == 'undefined') {
                var mode = 'append';
            }
            var img = $('<img/>', {
                src: typeof(baseDir)=='undefined'?'../modules/filkers/views/img/loading.svg':baseDir+'modules/filkers/views/img/loading.svg',
                alt: 'loading...',
                style: 'position:relative;top:-1px',
                height: 32
            });
            var loader = $('<span/>', {
                class: 'filkers-loader',
                style: 'display:none;color:#E62E04'
            });
            $(loader).prepend(img);
            if (mode=='append') {
                $(obj).append(loader);
            } else if(mode=='prepend') {
                $(obj).prepend(loader);
            } else {
                $(obj).after(loader);
            }
            $(loader).fadeIn(100);            
        },
        isFinished: function(obj) {
            if (typeof obj == 'undefined') {
                var obj = $('.filkers-loading');
            }
            $(obj).find('.filkers-loader').fadeOut(100, function(){
                $(this).remove();
            });
        },
        updateStatus: function(params, data) {
            if (data.success == 1) {
                $('.filkers_status').removeClass('alert-warning').removeClass('alert-danger').addClass('alert-success').html(filkers_connected);
            } else {
                $('.filkers_status').removeClass('alert-success').removeClass('alert-warning').addClass('alert-danger').html(filkers_disconnected);
            }
        }
    }

    $(document).on('click', '.copy-input', function() {
        var id = $(this).closest('.input-group').find('input[type=text]').attr('id');
        var copyText = document.getElementById(id);
        copyText.select();
        copyText.setSelectionRange(0, 99999);
        /*For mobile devices*/
        document.execCommand("copy");
    });

    $(document).on('click', '#filkers_get_authorization', function() {
        var params = {
            'action': 'getAuthorization',
        };
        filkers.ajaxCall(params, 'filkers.updateStatus');
    });
});
